#ifndef lint
static char yysccsid[] = "@(#)yaccpar	1.9 (Berkeley) 02/21/93";
#endif
#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define yyclearin (yychar=(-1))
#define yyerrok (yyerrflag=0)
#define YYRECOVERING (yyerrflag!=0)
#define YYPREFIX "yy"
#line 2 "gram.y"
/*	$NetBSD: gram.y,v 1.7 1996/03/17 13:18:18 cgd Exp $	*/

/*
 * Copyright (c) 1992, 1993
 *	The Regents of the University of California.  All rights reserved.
 *
 * This software was developed by the Computer Systems Engineering group
 * at Lawrence Berkeley Laboratory under DARPA contract BG 91-66 and
 * contributed to Berkeley.
 *
 * All advertising materials mentioning features or use of this software
 * must display the following acknowledgement:
 *	This product includes software developed by the University of
 *	California, Lawrence Berkeley Laboratories.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by the University of
 *	California, Berkeley and its contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 *	from: @(#)gram.y	8.1 (Berkeley) 6/6/93
 */

#include <sys/param.h>
#include <ctype.h>
#include <paths.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "config.h"
#include "sem.h"

#define	FORMAT(n) ((n) > -10 && (n) < 10 ? "%d" : "0x%x")

#define	stop(s)	error(s), exit(1)

int	include __P((const char *, int));
void	yyerror __P((const char *));
int	yylex __P((void));
extern const char *lastfile;

static	struct	config conf;	/* at most one active at a time */

/* the following is used to recover nvlist space after errors */
static	struct	nvlist *alloc[1000];
static	int	adepth;
#define	new0(n,s,p,i,x)	(alloc[adepth++] = newnv(n, s, p, i, x))
#define	new_n(n)	new0(n, NULL, NULL, 0, NULL)
#define	new_nx(n, x)	new0(n, NULL, NULL, 0, x)
#define	new_ns(n, s)	new0(n, s, NULL, 0, NULL)
#define	new_si(s, i)	new0(NULL, s, NULL, i, NULL)
#define	new_nsi(n,s,i)	new0(n, s, NULL, i, NULL)
#define	new_np(n, p)	new0(n, NULL, p, 0, NULL)
#define	new_s(s)	new0(NULL, s, NULL, 0, NULL)
#define	new_p(p)	new0(NULL, NULL, p, 0, NULL)
#define	new_px(p, x)	new0(NULL, NULL, p, 0, x)

#define	fx_atom(s)	new0(s, NULL, NULL, FX_ATOM, NULL)
#define	fx_not(e)	new0(NULL, NULL, NULL, FX_NOT, e)
#define	fx_and(e1, e2)	new0(NULL, NULL, e1, FX_AND, e2)
#define	fx_or(e1, e2)	new0(NULL, NULL, e1, FX_OR, e2)

static	void	cleanup __P((void));
static	void	setmachine __P((const char *, const char *));
static	void	setmaxpartitions __P((int));

#line 93 "gram.y"
typedef union {
	struct	attr *attr;
	struct	devbase *devb;
	struct	deva *deva;
	struct	nvlist *list;
	const char *str;
	int	val;
} YYSTYPE;
#line 111 "y.tab.c"
#define AND 257
#define AT 258
#define ATTACH 259
#define COMPILE_WITH 260
#define CONFIG 261
#define DEFINE 262
#define DEVICE 263
#define DUMPS 264
#define ENDFILE 265
#define XFILE 266
#define FLAGS 267
#define INCLUDE 268
#define XMACHINE 269
#define MAJOR 270
#define MAKEOPTIONS 271
#define MAXUSERS 272
#define MAXPARTITIONS 273
#define MINOR 274
#define ON 275
#define OPTIONS 276
#define PSEUDO_DEVICE 277
#define ROOT 278
#define SWAP 279
#define VECTOR 280
#define WITH 281
#define FFLAG 282
#define NUMBER 283
#define PATHNAME 284
#define WORD 285
#define YYERRCODE 256
short yylhs[] = {                                        -1,
    0,   31,   31,   37,   37,   32,   32,   32,   34,   39,
   39,   35,   35,   40,    1,    1,    2,    2,    2,    2,
    2,    3,    4,    4,    5,    5,   38,   33,   33,   41,
   41,   41,   42,   42,   42,   42,   42,   42,   42,   42,
    9,    9,   11,   11,   16,   16,   17,   17,    7,    8,
    8,   10,   10,   12,   12,   13,   13,   14,   14,   14,
   15,   26,   26,   28,   28,   18,   18,   19,   19,    6,
   43,   43,   44,   36,   36,   45,   45,   45,   46,   46,
   46,   46,   46,   46,   46,   46,   48,   48,   51,   47,
   47,   52,   52,   49,   50,   50,   53,   53,   53,   22,
   22,   23,   23,   27,   54,   54,   29,   29,   24,   24,
   25,   25,   25,   20,   20,   21,   21,   30,   30,
};
short yylen[] = {                                         2,
   10,    2,    0,    1,    1,    2,    3,    1,    1,    2,
    0,    3,    1,    5,    1,    0,    1,    2,    3,    3,
    3,    1,    2,    0,    2,    0,    2,    2,    0,    2,
    1,    2,    1,    1,    3,    4,    7,    4,    3,    4,
    3,    1,    1,    1,    2,    0,    2,    1,    1,    2,
    0,    3,    0,    1,    0,    3,    1,    2,    1,    4,
    2,    1,    1,    1,    2,    2,    0,    3,    1,    1,
    3,    1,    3,    2,    0,    2,    1,    2,    1,    1,
    2,    2,    2,    3,    3,    5,    3,    1,    3,    3,
    1,    1,    3,    1,    2,    1,    3,    3,    3,    3,
    1,    1,    1,    4,    1,    0,    1,    0,    2,    1,
    1,    2,    1,    2,    0,    2,    2,    2,    0,
};
short yydefred[] = {                                      3,
    0,    0,    8,    0,    0,    5,   29,    2,    4,   27,
    0,    0,    7,    0,    0,    0,    0,    9,    0,    0,
    0,    0,   31,   29,   34,   33,   28,    0,   32,   49,
    0,    0,    0,    0,    0,    0,    0,    0,   30,    0,
    0,   35,    0,   22,    0,    0,   24,    0,   17,    0,
    0,   72,    0,    0,   39,    0,   44,   43,    0,   42,
    0,    0,    0,   54,    0,   36,   18,    0,    0,    0,
    0,    0,   40,    0,   38,   70,   69,    0,   13,   29,
    0,    0,    0,    0,    0,   58,    0,   52,    0,   21,
    0,   23,   14,    0,    0,   73,   71,    0,    0,    0,
   10,    0,   45,   41,    0,    0,   64,   62,    0,   61,
   63,    0,   56,   25,   68,   75,   12,   47,   50,   37,
   65,   60,    0,    0,    0,    0,    0,    0,    0,    0,
   77,    0,   80,   79,   74,    0,   78,   94,    0,    0,
    0,   88,   83,    0,    0,   91,    0,  109,    0,   76,
    0,    0,    0,    0,   96,    0,    0,    0,    0,  107,
   85,  111,    0,  115,  105,    0,    0,    0,   95,   89,
   87,   93,   90,  112,    0,    0,  102,   99,  103,   97,
   98,    0,    0,    0,  114,   86,    0,    0,  118,  117,
  116,    0,  100,  104,
};
short yydgoto[] = {                                       1,
   47,   48,   49,   69,   93,   77,   50,  106,   59,   42,
   60,   63,   64,   65,   86,   84,  103,   55,   78,  175,
  185,  181,  182,  132,  164,  110,  179,  111,  161,  186,
    2,    7,   12,   24,   80,  123,    8,   25,   81,   26,
   27,   28,   51,   52,  135,  136,  145,  141,  139,  154,
  142,  146,  155,  166,
};
short yysindex[] = {                                      0,
    0,   53,    0, -229, -220,    0,    0,    0,    0,    0,
 -217,   31,    0,   60, -214, -213, -214,    0, -211,  -49,
 -208, -214,    0,    0,    0,    0,    0,   67,    0,    0,
 -180,  -43,  -43,  -15, -214, -202,   24,   31,    0, -239,
  -80,    0,   24,    0, -201,  -15,    0,  -21,    0,   25,
  -24,    0, -198, -197,    0, -169,    0,    0,  -38,    0,
   29, -194,  -33,    0,   49,    0,    0,  -22, -228,  -15,
  -15, -189,    0, -214,    0,    0,    0,   51,    0,    0,
   -5, -188, -239, -185,  -35,    0,   29,    0,  -80,    0,
 -187,    0,    0,  -21,  -21,    0,    0, -197,   31, -184,
    0, -188,    0,    0, -181,   24,    0,    0, -183,    0,
    0,   13,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  -10,   97, -177, -176, -173, -174, -172,   70,
    0, -144,    0,    0,    0,  105,    0,    0, -231,   55,
   73,    0,    0,   57,   75,    0, -163,    0, -225,    0,
 -154, -154, -154, -231,    0,  -35, -176,  -35, -174,    0,
    0,    0,   59,    0,    0, -230, -230, -230,    0,    0,
    0,    0,    0,    0, -233, -160,    0,    0,    0,    0,
    0, -133, -158,  -36,    0,    0, -148, -230,    0,    0,
    0, -156,    0,    0,
};
short yyrindex[] = {                                      0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   48,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  118,   11,    3,    0,    0,  119,    0,    0,    0,
    6,    0,  119,    0,    0,    0,    0,    4,    0,    0,
    0,    0,    0,    0,    0,   -2,    0,    0,   -9,    0,
  -20,    0,    0,    0,    7,    0,    0,    0,  120,    0,
    0,    0,    0,    0,    0,    0,    0,  124,    0,    0,
    0,    0,    0,   18,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   -6,   -3,    0,    0,    0,    0,    0,
    0,   -7,    0,    0,    0,  119,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  135,    0,    0,    0,    0,    0,    0, -122,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  127,    0,    0,   20,  128,    0,  129,    0,    0,    0,
 -226, -226, -226,  130,    0,    0,    0,    0,    0,    0,
    0,    0,   -8,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  131,    0,    0,    0,    0,    0,
    0,    5,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,
};
short yygindex[] = {                                      0,
    0,   -4,   98,    0,    0,   44,   28,    0,    0,  111,
   62,    0,   58,    0,   61,    0,   47,  -17,    0,    0,
    0,  -42, -130,    0,    0, -127,    0,    0,    0,    0,
    0,    0,   -1,  -16,    0,    0,    0,   10,    0,   27,
    0,    0,    0,   77,    0,    0,    0,    0,    0,    0,
    1,    2,    8,  -91,
};
#define YYTABLESIZE 325
short yytable[] = {                                     131,
   46,  113,   48,   19,  101,   83,   20,   11,  109,  109,
   62,    9,   16,   15,  101,   70,   70,   45,   90,   74,
   53,   56,   38,   59,   46,   66,  190,   51,  170,   92,
  172,   91,  151,  183,   19,  178,  180,   20,   57,  176,
   23,   68,   31,  106,   33,   58,  152,  153,   46,   37,
   48,  184,  162,   92,  177,   10,  191,    6,  106,  163,
  167,  168,    6,   92,   11,   94,   95,   13,   53,   29,
   30,   32,   34,   35,   36,   51,   39,   40,   99,   41,
   53,   54,  116,   44,   75,   72,   79,   76,  120,   85,
   87,   88,   89,   96,   98,  105,  102,  114,  117,  121,
   73,   71,   71,  119,   59,  122,  137,  138,  140,  143,
  144,  148,  147,  149,  150,  156,  157,  158,  159,  160,
  165,  174,  187,  188,  189,  192,  194,   53,   67,   26,
   55,   57,  133,   66,    1,  110,   82,   81,  108,   84,
  119,  115,   67,   43,  104,  193,  113,  112,  118,  134,
   97,    0,    0,    0,    0,    0,    0,  171,    0,    0,
  173,  169,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   61,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   82,    0,    0,    0,  124,  107,  107,  108,  108,
  125,    0,    0,   19,    0,   19,   20,    4,  113,    0,
  126,  127,   16,   15,    0,  128,  129,  100,  101,   44,
   11,   46,    0,   48,  130,   19,  113,    0,   20,    0,
    0,    0,  101,  101,   16,   15,   14,    0,    0,   15,
    0,    0,   16,   17,    0,   18,   19,    0,    4,    0,
   20,    0,   21,    6,    0,    0,    6,   22,    3,    6,
    6,    0,    6,    6,    0,    6,    0,    6,    0,    6,
    4,    5,    0,    0,    6,
};
short yycheck[] = {                                      10,
   10,   10,   10,   10,   10,   44,   10,   10,   45,   45,
   91,    2,   10,   10,   10,   38,   38,   33,   41,   44,
   10,   38,   24,   44,   40,   43,   63,   10,  156,   10,
  158,  260,  264,  267,   41,  166,  167,   41,  278,  270,
   10,   46,   15,  270,   17,  285,  278,  279,   58,   22,
   58,  285,  278,  282,  285,  285,  184,   10,  285,  285,
  152,  153,   10,   44,  285,   70,   71,  285,   58,   10,
  285,  285,  284,  123,  283,   58,   10,  258,   80,  123,
  283,   58,   99,  285,  283,   61,  256,  285,  106,   61,
  285,  125,   44,  283,   44,  281,  285,  285,  283,  283,
  125,  124,  124,  285,  125,   93,   10,  285,  285,  283,
  285,   42,  285,  258,   10,   61,   44,   61,   44,  283,
  275,   63,  283,  257,  283,  274,  283,   10,   10,   10,
  125,  125,  123,   10,    0,  258,   10,   10,   10,   10,
   10,   98,   45,   33,   83,  188,   89,   87,  102,  123,
   74,   -1,   -1,   -1,   -1,   -1,   -1,  157,   -1,   -1,
  159,  154,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  285,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  280,   -1,   -1,   -1,  256,  283,  283,  285,  285,
  261,   -1,   -1,  260,   -1,  266,  260,  268,  267,   -1,
  271,  272,  260,  260,   -1,  276,  277,  273,  264,  285,
  273,  281,   -1,  281,  285,  282,  285,   -1,  282,   -1,
   -1,   -1,  278,  279,  282,  282,  256,   -1,   -1,  259,
   -1,   -1,  262,  263,   -1,  265,  266,   -1,  268,   -1,
  270,   -1,  272,  256,   -1,   -1,  259,  277,  256,  262,
  263,   -1,  265,  266,   -1,  268,   -1,  270,   -1,  272,
  268,  269,   -1,   -1,  277,
};
#define YYFINAL 1
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 285
#if YYDEBUG
char *yyname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,"'\\n'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,"'!'",0,0,0,0,"'&'",0,"'('","')'","'*'",0,"','","'-'",0,0,0,0,0,0,0,0,0,0,0,
0,"':'",0,0,"'='",0,"'?'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
"'['",0,"']'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"'{'",
"'|'","'}'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"AND","AT","ATTACH","COMPILE_WITH","CONFIG",
"DEFINE","DEVICE","DUMPS","ENDFILE","XFILE","FLAGS","INCLUDE","XMACHINE",
"MAJOR","MAKEOPTIONS","MAXUSERS","MAXPARTITIONS","MINOR","ON","OPTIONS",
"PSEUDO_DEVICE","ROOT","SWAP","VECTOR","WITH","FFLAG","NUMBER","PATHNAME",
"WORD",
};
char *yyrule[] = {
"$accept : Configuration",
"Configuration : hdrs machine_spec dev_defs dev_eof dev_defs dev_eof maxpart_spec dev_defs dev_eof specs",
"hdrs : hdrs hdr",
"hdrs :",
"hdr : include",
"hdr : '\\n'",
"machine_spec : XMACHINE WORD",
"machine_spec : XMACHINE WORD WORD",
"machine_spec : error",
"dev_eof : ENDFILE",
"maxpart_blanks : maxpart_blanks '\\n'",
"maxpart_blanks :",
"maxpart_spec : maxpart_blanks MAXPARTITIONS NUMBER",
"maxpart_spec : error",
"file : XFILE PATHNAME fopts fflgs rule",
"fopts : fexpr",
"fopts :",
"fexpr : fatom",
"fexpr : '!' fatom",
"fexpr : fexpr '&' fexpr",
"fexpr : fexpr '|' fexpr",
"fexpr : '(' fexpr ')'",
"fatom : WORD",
"fflgs : fflgs FFLAG",
"fflgs :",
"rule : COMPILE_WITH WORD",
"rule :",
"include : INCLUDE WORD",
"dev_defs : dev_defs dev_def",
"dev_defs :",
"dev_def : one_def '\\n'",
"dev_def : '\\n'",
"dev_def : error '\\n'",
"one_def : file",
"one_def : include",
"one_def : DEFINE WORD interface_opt",
"one_def : DEVICE devbase interface_opt attrs_opt",
"one_def : ATTACH devbase AT atlist veclist_opt devattach_opt attrs_opt",
"one_def : MAXUSERS NUMBER NUMBER NUMBER",
"one_def : PSEUDO_DEVICE devbase attrs_opt",
"one_def : MAJOR '{' majorlist '}'",
"atlist : atlist ',' atname",
"atlist : atname",
"atname : WORD",
"atname : ROOT",
"veclist_opt : VECTOR veclist",
"veclist_opt :",
"veclist : WORD veclist",
"veclist : WORD",
"devbase : WORD",
"devattach_opt : WITH WORD",
"devattach_opt :",
"interface_opt : '{' loclist_opt '}'",
"interface_opt :",
"loclist_opt : loclist",
"loclist_opt :",
"loclist : locdef ',' loclist",
"loclist : locdef",
"locdef : WORD locdefault",
"locdef : WORD",
"locdef : '[' WORD locdefault ']'",
"locdefault : '=' value",
"value : WORD",
"value : signed_number",
"signed_number : NUMBER",
"signed_number : '-' NUMBER",
"attrs_opt : ':' attrs",
"attrs_opt :",
"attrs : attrs ',' attr",
"attrs : attr",
"attr : WORD",
"majorlist : majorlist ',' majordef",
"majorlist : majordef",
"majordef : devbase '=' NUMBER",
"specs : specs spec",
"specs :",
"spec : config_spec '\\n'",
"spec : '\\n'",
"spec : error '\\n'",
"config_spec : file",
"config_spec : include",
"config_spec : OPTIONS opt_list",
"config_spec : MAKEOPTIONS mkopt_list",
"config_spec : MAXUSERS NUMBER",
"config_spec : CONFIG conf sysparam_list",
"config_spec : PSEUDO_DEVICE WORD npseudo",
"config_spec : device_instance AT attachment locators flags_opt",
"mkopt_list : mkopt_list ',' mkoption",
"mkopt_list : mkoption",
"mkoption : WORD '=' value",
"opt_list : opt_list ',' option",
"opt_list : option",
"option : WORD",
"option : WORD '=' value",
"conf : WORD",
"sysparam_list : sysparam_list sysparam",
"sysparam_list : sysparam",
"sysparam : ROOT on_opt dev_spec",
"sysparam : SWAP on_opt swapdev_list",
"sysparam : DUMPS on_opt dev_spec",
"swapdev_list : dev_spec AND swapdev_list",
"swapdev_list : dev_spec",
"dev_spec : WORD",
"dev_spec : major_minor",
"major_minor : MAJOR NUMBER MINOR NUMBER",
"on_opt : ON",
"on_opt :",
"npseudo : NUMBER",
"npseudo :",
"device_instance : WORD '*'",
"device_instance : WORD",
"attachment : ROOT",
"attachment : WORD '?'",
"attachment : WORD",
"locators : locators locator",
"locators :",
"locator : WORD value",
"locator : WORD '?'",
"flags_opt : FLAGS NUMBER",
"flags_opt :",
};
#endif
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 500
#define YYMAXDEPTH 500
#endif
#endif
int yydebug;
int yynerrs;
int yyerrflag;
int yychar;
short *yyssp;
YYSTYPE *yyvsp;
YYSTYPE yyval;
YYSTYPE yylval;
short yyss[YYSTACKSIZE];
YYSTYPE yyvs[YYSTACKSIZE];
#define yystacksize YYSTACKSIZE
#line 394 "gram.y"

void
yyerror(s)
	const char *s;
{

	error("%s", s);
}

/*
 * Cleanup procedure after syntax error: release any nvlists
 * allocated during parsing the current line.
 */
static void
cleanup()
{
	register struct nvlist **np;
	register int i;

	for (np = alloc, i = adepth; --i >= 0; np++)
		nvfree(*np);
	adepth = 0;
}

static void
setmachine(mch, mcharch)
	const char *mch;
	const char *mcharch;
{
	char buf[MAXPATHLEN], archbuf[MAXPATHLEN];

	machine = mch;
	machinearch = mcharch;
	if (machinearch != NULL)
		(void)sprintf(archbuf, "../../%s/conf/files.%s",
		    machinearch, machinearch);
	else
		strncpy(archbuf, _PATH_DEVNULL, MAXPATHLEN);
	(void)sprintf(buf, "files.%s", machine);

	if (include(buf, ENDFILE) ||
	    include(archbuf, ENDFILE) ||
	    include("../../../conf/files", ENDFILE))
		exit(1);
}

static void
setmaxpartitions(n)
	int n;
{

	maxpartitions = n;
}
#line 542 "y.tab.c"
#define YYABORT goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab
int
yyparse()
{
    register int yym, yyn, yystate;
#if YYDEBUG
    register char *yys;
    extern char *getenv();

    if (yys = getenv("YYDEBUG"))
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = (-1);

    yyssp = yyss;
    yyvsp = yyvs;
    *yyssp = yystate = 0;

yyloop:
    if (yyn = yydefred[yystate]) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]);
#endif
        if (yyssp >= yyss + yystacksize - 1)
        {
            goto yyoverflow;
        }
        *++yyssp = yystate = yytable[yyn];
        *++yyvsp = yylval;
        yychar = (-1);
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;
#ifdef lint
    goto yynewerror;
#endif
yynewerror:
    yyerror("syntax error");
#ifdef lint
    goto yyerrlab;
#endif
yyerrlab:
    ++yynerrs;
yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yyssp]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yyssp, yytable[yyn]);
#endif
                if (yyssp >= yyss + yystacksize - 1)
                {
                    goto yyoverflow;
                }
                *++yyssp = yystate = yytable[yyn];
                *++yyvsp = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yyssp);
#endif
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
        yychar = (-1);
        goto yyloop;
    }
yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    yyval = yyvsp[1-yym];
    switch (yyn)
    {
case 6:
#line 152 "gram.y"
 { setmachine(yyvsp[0].str,NULL); }
break;
case 7:
#line 153 "gram.y"
 { setmachine(yyvsp[-1].str,yyvsp[0].str); }
break;
case 8:
#line 154 "gram.y"
 { stop("cannot proceed without machine specifier"); }
break;
case 9:
#line 157 "gram.y"
 { enddefs(lastfile); checkfiles(); }
break;
case 12:
#line 164 "gram.y"
 { setmaxpartitions(yyvsp[0].val); }
break;
case 13:
#line 165 "gram.y"
 { stop("cannot proceed without maxpartitions specifier"); }
break;
case 14:
#line 171 "gram.y"
 { addfile(yyvsp[-3].str, yyvsp[-2].list, yyvsp[-1].val, yyvsp[0].str); }
break;
case 15:
#line 175 "gram.y"
 { yyval.list = yyvsp[0].list; }
break;
case 16:
#line 176 "gram.y"
 { yyval.list = NULL; }
break;
case 17:
#line 179 "gram.y"
 { yyval.list = yyvsp[0].list; }
break;
case 18:
#line 180 "gram.y"
 { yyval.list = fx_not(yyvsp[0].list); }
break;
case 19:
#line 181 "gram.y"
 { yyval.list = fx_and(yyvsp[-2].list, yyvsp[0].list); }
break;
case 20:
#line 182 "gram.y"
 { yyval.list = fx_or(yyvsp[-2].list, yyvsp[0].list); }
break;
case 21:
#line 183 "gram.y"
 { yyval.list = yyvsp[-1].list; }
break;
case 22:
#line 186 "gram.y"
 { yyval.list = fx_atom(yyvsp[0].str); }
break;
case 23:
#line 189 "gram.y"
 { yyval.val = yyvsp[-1].val | yyvsp[0].val; }
break;
case 24:
#line 190 "gram.y"
 { yyval.val = 0; }
break;
case 25:
#line 193 "gram.y"
 { yyval.str = yyvsp[0].str; }
break;
case 26:
#line 194 "gram.y"
 { yyval.str = NULL; }
break;
case 27:
#line 197 "gram.y"
 { (void)include(yyvsp[0].str, '\n'); }
break;
case 30:
#line 207 "gram.y"
 { adepth = 0; }
break;
case 32:
#line 209 "gram.y"
 { cleanup(); }
break;
case 35:
#line 214 "gram.y"
 { (void)defattr(yyvsp[-1].str, yyvsp[0].list); }
break;
case 36:
#line 216 "gram.y"
 { defdev(yyvsp[-2].devb, 0, yyvsp[-1].list, yyvsp[0].list); }
break;
case 37:
#line 218 "gram.y"
 { defdevattach(yyvsp[-1].deva, yyvsp[-5].devb, yyvsp[-3].list, yyvsp[-2].list,
					    yyvsp[0].list); }
break;
case 38:
#line 220 "gram.y"
 { setdefmaxusers(yyvsp[-2].val, yyvsp[-1].val, yyvsp[0].val); }
break;
case 39:
#line 221 "gram.y"
 { defdev(yyvsp[-1].devb,1,NULL,yyvsp[0].list); }
break;
case 41:
#line 225 "gram.y"
 { yyval.list = new_nx(yyvsp[0].str, yyvsp[-2].list); }
break;
case 42:
#line 226 "gram.y"
 { yyval.list = new_n(yyvsp[0].str); }
break;
case 43:
#line 229 "gram.y"
 { yyval.str = yyvsp[0].str; }
break;
case 44:
#line 230 "gram.y"
 { yyval.str = NULL; }
break;
case 45:
#line 233 "gram.y"
 { yyval.list = yyvsp[0].list; }
break;
case 46:
#line 234 "gram.y"
 { yyval.list = NULL; }
break;
case 47:
#line 238 "gram.y"
 { yyval.list = new_nx(yyvsp[-1].str, yyvsp[0].list); }
break;
case 48:
#line 239 "gram.y"
 { yyval.list = new_n(yyvsp[0].str); }
break;
case 49:
#line 242 "gram.y"
 { yyval.devb = getdevbase(yyvsp[0].str); }
break;
case 50:
#line 245 "gram.y"
 { yyval.deva = getdevattach(yyvsp[0].str); }
break;
case 51:
#line 246 "gram.y"
 { yyval.deva = NULL; }
break;
case 52:
#line 249 "gram.y"
 { yyval.list = new_nx("", yyvsp[-1].list); }
break;
case 53:
#line 250 "gram.y"
 { yyval.list = NULL; }
break;
case 54:
#line 253 "gram.y"
 { yyval.list = yyvsp[0].list; }
break;
case 55:
#line 254 "gram.y"
 { yyval.list = NULL; }
break;
case 56:
#line 258 "gram.y"
 { (yyval.list = yyvsp[-2].list)->nv_next = yyvsp[0].list; }
break;
case 57:
#line 259 "gram.y"
 { yyval.list = yyvsp[0].list; }
break;
case 58:
#line 263 "gram.y"
 { yyval.list = new_nsi(yyvsp[-1].str, yyvsp[0].str, 0); }
break;
case 59:
#line 264 "gram.y"
 { yyval.list = new_nsi(yyvsp[0].str, NULL, 0); }
break;
case 60:
#line 265 "gram.y"
 { yyval.list = new_nsi(yyvsp[-2].str, yyvsp[-1].str, 1); }
break;
case 61:
#line 268 "gram.y"
 { yyval.str = yyvsp[0].str; }
break;
case 62:
#line 271 "gram.y"
 { yyval.str = yyvsp[0].str; }
break;
case 63:
#line 272 "gram.y"
 { char bf[40];
					    (void)sprintf(bf, FORMAT(yyvsp[0].val), yyvsp[0].val);
					    yyval.str = intern(bf); }
break;
case 64:
#line 277 "gram.y"
 { yyval.val = yyvsp[0].val; }
break;
case 65:
#line 278 "gram.y"
 { yyval.val = -yyvsp[0].val; }
break;
case 66:
#line 281 "gram.y"
 { yyval.list = yyvsp[0].list; }
break;
case 67:
#line 282 "gram.y"
 { yyval.list = NULL; }
break;
case 68:
#line 285 "gram.y"
 { yyval.list = new_px(yyvsp[0].attr, yyvsp[-2].list); }
break;
case 69:
#line 286 "gram.y"
 { yyval.list = new_p(yyvsp[0].attr); }
break;
case 70:
#line 289 "gram.y"
 { yyval.attr = getattr(yyvsp[0].str); }
break;
case 73:
#line 296 "gram.y"
 { setmajor(yyvsp[-2].devb, yyvsp[0].val); }
break;
case 76:
#line 308 "gram.y"
 { adepth = 0; }
break;
case 78:
#line 310 "gram.y"
 { cleanup(); }
break;
case 83:
#line 317 "gram.y"
 { setmaxusers(yyvsp[0].val); }
break;
case 84:
#line 318 "gram.y"
 { addconf(&conf); }
break;
case 85:
#line 319 "gram.y"
 { addpseudo(yyvsp[-1].str, yyvsp[0].val); }
break;
case 86:
#line 321 "gram.y"
 { adddev(yyvsp[-4].str, yyvsp[-2].str, yyvsp[-1].list, yyvsp[0].val); }
break;
case 89:
#line 328 "gram.y"
 { addmkoption(yyvsp[-2].str, yyvsp[0].str); }
break;
case 92:
#line 335 "gram.y"
 { addoption(yyvsp[0].str, NULL); }
break;
case 93:
#line 336 "gram.y"
 { addoption(yyvsp[-2].str, yyvsp[0].str); }
break;
case 94:
#line 339 "gram.y"
 { conf.cf_name = yyvsp[0].str;
					    conf.cf_lineno = currentline();
					    conf.cf_root = NULL;
					    conf.cf_swap = NULL;
					    conf.cf_dump = NULL; }
break;
case 97:
#line 350 "gram.y"
 { setconf(&conf.cf_root, "root", yyvsp[0].list); }
break;
case 98:
#line 351 "gram.y"
 { setconf(&conf.cf_swap, "swap", yyvsp[0].list); }
break;
case 99:
#line 352 "gram.y"
 { setconf(&conf.cf_dump, "dumps", yyvsp[0].list); }
break;
case 100:
#line 355 "gram.y"
 { (yyval.list = yyvsp[-2].list)->nv_next = yyvsp[0].list; }
break;
case 101:
#line 356 "gram.y"
 { yyval.list = yyvsp[0].list; }
break;
case 102:
#line 359 "gram.y"
 { yyval.list = new_si(yyvsp[0].str, NODEV); }
break;
case 103:
#line 360 "gram.y"
 { yyval.list = new_si(NULL, yyvsp[0].val); }
break;
case 104:
#line 363 "gram.y"
 { yyval.val = makedev(yyvsp[-2].val, yyvsp[0].val); }
break;
case 107:
#line 369 "gram.y"
 { yyval.val = yyvsp[0].val; }
break;
case 108:
#line 370 "gram.y"
 { yyval.val = 1; }
break;
case 109:
#line 373 "gram.y"
 { yyval.str = starref(yyvsp[-1].str); }
break;
case 110:
#line 374 "gram.y"
 { yyval.str = yyvsp[0].str; }
break;
case 111:
#line 377 "gram.y"
 { yyval.str = NULL; }
break;
case 112:
#line 378 "gram.y"
 { yyval.str = wildref(yyvsp[-1].str); }
break;
case 113:
#line 379 "gram.y"
 { yyval.str = yyvsp[0].str; }
break;
case 114:
#line 382 "gram.y"
 { (yyval.list = yyvsp[0].list)->nv_next = yyvsp[-1].list; }
break;
case 115:
#line 383 "gram.y"
 { yyval.list = NULL; }
break;
case 116:
#line 386 "gram.y"
 { yyval.list = new_ns(yyvsp[-1].str, yyvsp[0].str); }
break;
case 117:
#line 387 "gram.y"
 { yyval.list = new_ns(yyvsp[-1].str, NULL); }
break;
case 118:
#line 390 "gram.y"
 { yyval.val = yyvsp[0].val; }
break;
case 119:
#line 391 "gram.y"
 { yyval.val = 0; }
break;
#line 1046 "y.tab.c"
    }
    yyssp -= yym;
    yystate = *yyssp;
    yyvsp -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yyssp, yystate);
#endif
    if (yyssp >= yyss + yystacksize - 1)
    {
        goto yyoverflow;
    }
    *++yyssp = yystate;
    *++yyvsp = yyval;
    goto yyloop;
yyoverflow:
    yyerror("yacc stack overflow");
yyabort:
    return (1);
yyaccept:
    return (0);
}
